typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct {
  unsigned int X_Min;
  unsigned int X_Max;
  unsigned int Y_Min;
  unsigned int Y_Max;
  char         Rotate;
} TTPConstants;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  TTextAlignVertical TextAlignVertical;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          VerticalText;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  First_Point_X;
  unsigned int  First_Point_Y;
  unsigned int  Second_Point_X;
  unsigned int  Second_Point_Y;
  char          Pen_Width;
  char          Visible;
  unsigned int  Color;
} TLine;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned int           ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           LinesCount;
  TLine                  * const code *Lines;
};

extern   TScreen                Screen1;
extern   TLine                  Line1;
extern   TLine                  Line2;
extern   TLine                  Line3;
extern   TLine                  Line4;
extern   TBox                   Box1;
extern   TBox                   Box2;
extern   TLabel                 Temp_value;
extern   TLabel                 Pressure_value;
extern   TLabel                 Label1;
extern   TLabel                 Label2;
extern   TBox                   Box3;
extern   TLabel                 Label13;
extern   TBox                   Box4;
extern   TLabel                 Label14;
extern   TLine                  Line7;
extern   TLine                  Line8;
extern   TLine                  Line9;
extern   TLine                  Line10;
extern   TLabel                 Label15;
extern   TLabel                 Label3;
extern   TLabel                 * const code Screen1_Labels[8];
extern   TBox                   * const code Screen1_Boxes[4];
extern   TLine                  * const code Screen1_Lines[8];

extern   TScreen                Screen2;
extern   TLabel                 Label16;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TBox                   Box5;
extern   TLabel                 hour1;
extern   TBox                   Box6;
extern   TLabel                 minute1;
extern   TBox                   Box7;
extern   TLabel                 sec1;
extern   TLabel                 Label22;
extern   TLabel                 Label23;
extern   TBox                   Box8;
extern   TLabel                 date1;
extern   TBox                   Box9;
extern   TLabel                 month1;
extern   TLabel                 Label30;
extern   TLabel                 Label31;
extern   TBox                   Box11;
extern   TLabel                 year1;
extern   TLabel                 Label17;
extern   TLabel                 Label18;
extern   TLabel                 Label19;
extern   TLabel                 Label20;
extern   TLabel                 Label21;
extern   TLabel                 Label24;
extern   TLabel                 Label25;
extern   TLabel                 Label26;
extern   TBox                   Box10;
extern   TLabel                 Label4;
extern   TLabel                 Alarm0;
extern   TLabel                 Alarm1;
extern   TLabel                 Alarm2;
extern   TLabel                 Alarm3;
extern   TButton                * const code Screen2_Buttons[10];
extern   TLabel                 * const code Screen2_Labels[24];
extern   TBox                   * const code Screen2_Boxes[7];


/////////////////////////
// Events Code Declarations
void Button10OnClick();
void Button1OnClick();
void Button2OnClick();
void Button3OnClick();
void Button4OnClick();
void Button5OnClick();
void Button6OnClick();
void Button7OnClick();
void Button8OnClick();
void Button9OnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Line1_Caption[];
extern char Line2_Caption[];
extern char Line3_Caption[];
extern char Line4_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Temp_value_Caption[];
extern char Pressure_value_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Box3_Caption[];
extern char Label13_Caption[];
extern char Box4_Caption[];
extern char Label14_Caption[];
extern char Line7_Caption[];
extern char Line8_Caption[];
extern char Line9_Caption[];
extern char Line10_Caption[];
extern char Label15_Caption[];
extern char Label3_Caption[];
extern char Label16_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char Box5_Caption[];
extern char hour1_Caption[];
extern char Box6_Caption[];
extern char minute1_Caption[];
extern char Box7_Caption[];
extern char sec1_Caption[];
extern char Label22_Caption[];
extern char Label23_Caption[];
extern char Box8_Caption[];
extern char date1_Caption[];
extern char Box9_Caption[];
extern char month1_Caption[];
extern char Label30_Caption[];
extern char Label31_Caption[];
extern char Box11_Caption[];
extern char year1_Caption[];
extern char Label17_Caption[];
extern char Label18_Caption[];
extern char Label19_Caption[];
extern char Label20_Caption[];
extern char Label21_Caption[];
extern char Label24_Caption[];
extern char Label25_Caption[];
extern char Label26_Caption[];
extern char Box10_Caption[];
extern char Label4_Caption[];
extern char Alarm0_Caption[];
extern char Alarm1_Caption[];
extern char Alarm2_Caption[];
extern char Alarm3_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
